package org.expeditee.gio.gesture.data;

import org.expeditee.core.Point;

public class SelectAreaGestureData extends ItemSpecificGestureData {

	private Point _draggedFrom;
	private boolean _finishedDragging;
	
	public SelectAreaGestureData(Point moveTo, Point draggedFrom, boolean finishedDragging)
	{
		super(moveTo);
		if (draggedFrom != null) _draggedFrom = draggedFrom.clone();
		_finishedDragging = finishedDragging;
	}
	
	public SelectAreaGestureData(Point moveTo, Point draggedFrom)
	{
		this(moveTo, draggedFrom, false);
	}
	
	public SelectAreaGestureData(Point moveTo)
	{
		this(moveTo, null, false);
	}
	
	public SelectAreaGestureData()
	{
		super(false);
		_draggedFrom = null;
		_finishedDragging = true;
	}
	
	public SelectAreaGestureData(SelectAreaGestureData other)
	{
		super(other);
		if (other != null) {
			if (other._draggedFrom != null) _draggedFrom = other._draggedFrom.clone();
			_finishedDragging = other._finishedDragging;
		}
	}
	
	public SelectAreaGestureData carryOn(Point moveTo)
	{
		SelectAreaGestureData data = this.clone();
		data._position = moveTo;
		return data;
	}
	
	public SelectAreaGestureData finalise()
	{
		SelectAreaGestureData data = this.clone();
		data._finishedDragging = true;
		return data;
	}
	
	public boolean wasDragged()
	{
		return _draggedFrom != null;
	}
	
	public Point getDraggedFrom()
	{
		if (_draggedFrom == null) return null;
		
		return _draggedFrom.clone();
	}
	
	public boolean getFinishedDragging()
	{
		return _finishedDragging;
	}
	
	public SelectAreaGestureData clone()
	{
		return new SelectAreaGestureData(this);
	}
}
